#pragma once

#include <string>
#include <functional>

namespace vortex {

    using interrupt_callback_t = std::function<void()>;

    void setup_keyboard_interrupt();
    void setup_keyboard_interrupt(interrupt_callback_t&& callback);
    bool check_keyboard_interrupt();

    void setup_realtime();
    void setup_tcp_low_latency();

    void set_thread_name(const std::string& name);

#if defined(WIN32) || defined(_WIN32)
    std::string last_error_message();
    std::string error_message(unsigned long error);
#endif

}
